# WSCF

WSCF (WebSocket Communication Foundation) 就是 抄 微软的WCF， 但有 推送功能。  

# 1. 项目描述
**WSCF** 基于 .net framework 4.6.1 <br>
**WSCF.standard** 可以在 .net core 跑的 <br>
**WSCF.Test** 项目测试 库<br>
**WSCF.Test.Client** 测试客户端<br>
**WSCF.Test.Server** 测试服务器<br>
<br>
**WSCF.RevCtrl.Test** 反向控制项目测试<br>
**WSCF.RevCtrl.Test.Client** 反向控制项目.测试客户端<br>
**WSCF.RevCtrl.Test.Server** 反向控制项目.测试服务器<br>
<br>
<br>
<br>
名词解释：<br>
Xxx 服务 <br>
IXxxService 服务接口 <br>
Proxy 在远端中的 服务代理<br>
XXXServiceClient 在本地 中的服务代理<br>



# 正向控制
正向控制： 客户端连接服务器，远程调用在服务器中的服务接口

## 1. 使用方法
1. 定义服务接口 IXXXService

//WSCF.Test/IService/IFooService.cs

2. 在服务器中，创建 类 XXX 实现 IXXXService 接口

//WSCF.Test/Server/Foo.cs

3. 在服务器中，

//WSCF.Test/Server.WsProxy/WsProxy.cs
```csharp
wssv = new WebSocketServer($"ws://{addr}/");
wssv.AddWebSocketService<Reflect_Proxy>("/Foo", (wsproxy) =>
{
    //IFooService 服务接口, foo 继承IFooService的类Foo 的对象
    wsproxy.Init(typeof(IFooService), foo); 
});

//如果有多个服务，就继续 wssv.AddWebSocketService<Reflect_Proxy>
this.wssv.Start();
```

4. 在客户端中

创建 类 XXXServiceClient 实现 IXXXService 接口

//WSCF.Test/ServiceClient/FooServiceClient.cs

最后使用
```csharp

//后面的 "foo" 是连接的名字，对应 地址 { Addr = "127.0.0.1:5540", ConnName = "foo" } 
// WSCF.FObjServiceClientManager 负责维护这个地址列表
Foo = new WSCF.Test.ServiceClient.FooServiceClient("Foo", true, "foo");
```


<br>
<br>
<br>
<br>


## 2. 描述

服务代理 它还另一个版本 在项目 FObjBase.Reflect

1. 如果代理的对象为 INotifyPropertyChanged, 对象内的 property 改变，能推送给客户端( [JsonIgnore] 除外);
2. 代理的对象不为INotifyPropertyChanged, 但 对象内的 property 

    + 是 [PropertyPush], 
    + 且是 INotifyPropertyChanged, 
    + 且 只能是get,不能有set

 那这个 property 内的 子property 改变，也会推送给 客户端 且 子property 是 [PropertyPush]，会继续向下全部注册 PropertyChanged, 也推送给 客户端;

3. 客户端 可以通过 Call(.....) 调用 服务 的function,  function返回的内容，需要通过[Call(...)] 定义; 且function 必须是 
```csharp
    void function(object param1, object param2,object paramN, AsyncCBHandler asyncDelegate, object asyncContext);
    //必须有参数 AsyncCBHandler asyncDelegate, object asyncContext， 名字不能改。 前面的 param1~paramN， 多少个都行
```
4. 服务中的event, 通过 [Push(...)] 可以推送给客户端， 但event 只能是 EventHandler
```csharp
     [Push(typeof(BulkDBTempFrameChangedEventArgs))]
     public event EventHandler TempFrameChanged;
```
5. websocket中的内容
```typescript
    class PkgData
    {
            /// <summary>
            /// Reverse Control Service Name 
            /// 服务器反向控制客户端时，处于客户端的服务名称;
            /// 当 为null 或 empty，为正向控制
            /// </summary>
            rcsn:string;

            /// <summary>
            /// 客户端 中全局唯一 交易 id, 客户端添加这个guid,
            /// 服务器在返回包带有这个guid, 客户端就能分辨出这个交易
            /// </summary>
            guid:string;

            /// <summary>
            /// 交易名称 PkgName
            /// 取值只有 P
            /// PUSH_Event, //事件推送 服务器->客户端
            /// PUSH_PropertyChanged, //属性改变推送 服务器->客户端
            /// CALL_GetAllProperties, //获取全部属性 客户端->服务器 服务器->客户端 
            /// CALL_SetProperty,//属性设置 客户端->服务器 服务器->客户端
            /// CALL_MethodInvoke, //方法调用 客户端->服务器 服务器->客户端 
            /// </summary>
            name:string;

            /// <summary>
            /// 数据包实体
            /// </summary>
            data:object;
    }
```
+ PUSH_Event:
数据包实体 为 {name:string,data:object}
```typescript
例:
服务器->客户端:
{
    name:"PUSH_Event",
    data:{
        name:"DataChanged",//事件名称
        data:{//事件数据体
            Time:"2023-11-30T16:21:40.5925612+08:00",
            Msg:"hello"
        }
    }
}
```

+ PUSH_PropertyChanged:
数据包实体 为 {name:string,data:object}
```typescript
例:
服务器->客户端:
{
    name:"PUSH_PropertyChanged",
    data:{
        name:"Msg",
        data:"hello"
    }
}
```


+ CALL_GetAllProperties:
数据包实体 为对象的全部属性 <br>
```typescript
例:
客户端->服务器:
{
    name:"CALL_GetAllProperties"
}
服务器->客户端:
{
    name:"CALL_GetAllProperties",
    data:{
        Msg:"hello",
        Number:1
    }
}
```
+ CALL_SetProperty:
数据包为属性对
{
    name:string;
    data:object;
}
```typescript
例:
客户端->服务器:
{
    name:"CALL_SetProperty",
    data:{
        name:"Msg",
        data:"hello"
    }
}
服务器 的对象中的属性改变了，会触发PUSH_PropertyChanged
```

+ CALL_MethodInvoke:
数据包为属性对
{
    name:string;
    data:object;
}

```typescript
例:
客户端->服务器:
{
    guid:"0002",//唯一标识,可以分辨哪次方法调用的返回
    name:"CALL_MethodInvoke",
    data:{
        name:"Add",//方法名称
        data:{//方法参数
            a:123,
            b:456
        }
    }
}
服务器->客户端:
{
    guid:"0002",
    name:"CALL_MethodInvoke",
    data:{//方法返回
        result:579
    }
}


```


<br><br><br><br><br><br><br><br><br>

# 反向控制
反向控制: 服务器 通过 客户端 connect 过来的通道 连接 在客户端服务代理。<br>
使用场景：<br>
    服务器 需要独立控制某个客户端



## 1. 使用方法

### 1.1 在服务器程序需要用到的
<br>

1. 在服务器中创建服务代理时，<br>
把
```csharp
wssv.AddWebSocketService<Reflect_Proxy>()
```
改为
```csharp
wssv.AddWebSocketService<RevCtrl_Proxy>()
```

服务对象 必须继承 WSCF.RevCtrl.IRevCtrlAdmin<br>
//RevCtrl.Test/WSCF.RevCtrl.Test.Server/Server/WsProxy.cs


2. 在服务对象实现时，<br>
在有回复的函数中：
```csharp
public void SendMsgToPrivateChat(string targetGuid, string msg, AsyncCBHandler asyncDelegate, object asyncContext)
        {
            var cc = asyncContext as WSCF.CC;
            var customerContext = customerContexts.Find(c => c.revCtrl_Proxy == cc.proxy);//cc.proxy 就是 RevCtrl_Proxy
```

有了 RevCtrl_Proxy, 就能通过 AddClient 添加 **服务的ServiceClient**
```csharp
RevCtrl_Proxy.AddClient("服务名称", 服务的ServiceClient);
```

除了在 有回复的函数 获取RevCtrl_Proxy, 还能通过 **WSCF.RevCtrl.IRevCtrlAdmin** 获取 **RevCtrl_Proxy**
```csharp
    public interface IRevCtrlAdmin
    {
        void OnOpen(RevCtrl_Proxy proxy);//连接建立

        void OnClose(RevCtrl_Proxy proxy);//连接关闭

        void OnDispose(RevCtrl_Proxy proxy);//连接释放
    }
```
//RevCtrl.Test/WSCF.RevCtrl.Test.Server/Server/Chat.cs


3. 在已有的连接中，在添加的 **服务的ServiceClient** , 不再继承 ~~Feflect_ServiceClient~~ ，需要 继承 **WsServiceClient**
//RevCtrl.Test/WSCF.RevCtrl.Test.Server/ServiceClient/CustomerServiceClient.cs


### 1.2 在客户端程序需要用到的
<br>

1.  能支持反向控制的 **服务的ServiceClient** 必须继承 **RevCtrl_ServiceClient**
//RevCtrl.Test/WSCF.RevCtrl.Test.Client/ServiceClient/ChatServiceClient.cs

2. 把在客户端中的 服务代理 挂在到 **RevCtrl_ServiceClient**
```csharp
//创建本地 顾客 
customer = new Customer();

//创建并且连接到 服务器的 Chat 服务
chatService = new ChatServiceClient("Chat", true, connName);

//创建 顾客功能 服务代理， 给服务器反向控制 顾客
var wsServiceProxy = new WsServiceProxy();
wsServiceProxy.Init(typeof(ICustomerService), customer);
chatService.AddProxy("Customer", wsServiceProxy); //挂载服务
```

