﻿using Newtonsoft.Json.Linq;

namespace WSCF
{

    public class Reflect_OBJ_INTERFACE
    {
        public const string paramName_asyncDelegate = "asyncDelegate";
        public const string paramName_asyncContext = "asyncContext";

        /// <summary>
        /// PkgData 的 data 实体
        /// </summary>
        public class ReflectData
        {
            public string name;
            public JToken data;
        }


        /// <summary>
        /// 
        /// </summary>
        public class PkgData
        {
            /// <summary>
            /// Reverse Control Service Name 
            /// 服务器反向控制客户端时，处于客户端的服务名称;
            /// 当 为null 或 empty，为正向控制
            /// </summary>
            public string rcsn;

            /// <summary>
            /// 客户端 中全局唯一 交易 id
            /// </summary>
            public string guid;

            /// <summary>
            /// PkgName 的 string 
            /// </summary>
            public string name;

            /// <summary>
            /// 数据包实体
            /// </summary>
            public JToken data;

            public PkgData() { }

            /// <summary>
            /// 正向控制 通讯包
            /// </summary>
            /// <param name="name"></param>
            /// <param name="guid"></param>
            /// <param name="data"></param>
            public PkgData(PkgName name, string guid, JToken data)
            {
                this.name = name.ToString();
                this.guid = guid;
                this.data = data;
            }
            /// <summary>
            /// 反向控制 通讯包
            /// </summary>
            /// <param name="rcsn">反向控制 服务名称</param>
            /// <param name="name">包功能名称</param>
            /// <param name="guid">全局ID</param>
            /// <param name="data">json数据包</param>
            public PkgData(string rcsn, PkgName name, string guid, JToken data)
            {
                this.rcsn = rcsn;
                this.name = name.ToString();
                this.guid = guid;
                this.data = data;
            }
        }
        public enum PkgName
        {
            PUSH_Event,
            PUSH_PropertyChanged,
            CALL_GetAllProperties,
            CALL_SetProperty,
            CALL_MethodInvoke,
            /// <summary>
            /// 不存在的服务
            /// </summary>
            ERR_NoService,
        }
    }
}
