﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static WSCF.Reflect_OBJ_INTERFACE;

namespace WSCF.RevCtrl
{
    public abstract class RevCtrl_ServiceClient : Reflect_SeviceClient
    {
        /// <summary>
        /// 客户端中， 提供给服务器反向控制用的全部服务
        /// </summary>
        Dictionary<string, WsServiceProxy> Proxys = new Dictionary<string, WsServiceProxy>();

        public RevCtrl_ServiceClient(string serverName, bool isByConnName, string addrOrConnName):base(serverName,isByConnName,addrOrConnName)
        {

        }

        public void AddProxy(string serviceName, WsServiceProxy proxy) 
        {
            proxy.SetSendEx(Send, serviceName);
            Proxys.Add(serviceName, proxy);
        }

        protected override void OnMessage(string msg)
        {
            //base.OnMessage(msg);
            string json = msg;

            var pkgData = Newtonsoft.Json.JsonConvert.DeserializeObject<PkgData>(json);


            if (string.IsNullOrEmpty(pkgData.rcsn))
            {
                //服务器 向 客户端  回复 服务 
                base.OnMessage(pkgData);
            }
            else
            {
                //服务器 反向控制 客户端， 客户端 的服务回复
                if (!Proxys.ContainsKey(pkgData.rcsn))
                {
                    //异常，没有发送过这个服务请求
                    pkgData.name = PkgName.ERR_NoService.ToString();

                    json = Newtonsoft.Json.JsonConvert.SerializeObject(pkgData);

                    Send(json);
                    return;
                }

                var proxy = Proxys[pkgData.rcsn];
                proxy.OnMessage(null, pkgData);
            }
        }
    }
}
